package com.chinaitop.depot.intelligent.fumigation.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TFumigationPlanExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TFumigationPlanExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andHouseIdIsNull() {
            addCriterion("house_id is null");
            return (Criteria) this;
        }

        public Criteria andHouseIdIsNotNull() {
            addCriterion("house_id is not null");
            return (Criteria) this;
        }

        public Criteria andHouseIdEqualTo(Integer value) {
            addCriterion("house_id =", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdNotEqualTo(Integer value) {
            addCriterion("house_id <>", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdGreaterThan(Integer value) {
            addCriterion("house_id >", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("house_id >=", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdLessThan(Integer value) {
            addCriterion("house_id <", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdLessThanOrEqualTo(Integer value) {
            addCriterion("house_id <=", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdIn(List<Integer> values) {
            addCriterion("house_id in", values, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdNotIn(List<Integer> values) {
            addCriterion("house_id not in", values, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdBetween(Integer value1, Integer value2) {
            addCriterion("house_id between", value1, value2, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdNotBetween(Integer value1, Integer value2) {
            addCriterion("house_id not between", value1, value2, "houseId");
            return (Criteria) this;
        }

        public Criteria andKeeperIsNull() {
            addCriterion("keeper is null");
            return (Criteria) this;
        }

        public Criteria andKeeperIsNotNull() {
            addCriterion("keeper is not null");
            return (Criteria) this;
        }

        public Criteria andKeeperEqualTo(Integer value) {
            addCriterion("keeper =", value, "keeper");
            return (Criteria) this;
        }

        public Criteria andKeeperNotEqualTo(Integer value) {
            addCriterion("keeper <>", value, "keeper");
            return (Criteria) this;
        }

        public Criteria andKeeperGreaterThan(Integer value) {
            addCriterion("keeper >", value, "keeper");
            return (Criteria) this;
        }

        public Criteria andKeeperGreaterThanOrEqualTo(Integer value) {
            addCriterion("keeper >=", value, "keeper");
            return (Criteria) this;
        }

        public Criteria andKeeperLessThan(Integer value) {
            addCriterion("keeper <", value, "keeper");
            return (Criteria) this;
        }

        public Criteria andKeeperLessThanOrEqualTo(Integer value) {
            addCriterion("keeper <=", value, "keeper");
            return (Criteria) this;
        }

        public Criteria andKeeperIn(List<Integer> values) {
            addCriterion("keeper in", values, "keeper");
            return (Criteria) this;
        }

        public Criteria andKeeperNotIn(List<Integer> values) {
            addCriterion("keeper not in", values, "keeper");
            return (Criteria) this;
        }

        public Criteria andKeeperBetween(Integer value1, Integer value2) {
            addCriterion("keeper between", value1, value2, "keeper");
            return (Criteria) this;
        }

        public Criteria andKeeperNotBetween(Integer value1, Integer value2) {
            addCriterion("keeper not between", value1, value2, "keeper");
            return (Criteria) this;
        }

        public Criteria andGrainKindIsNull() {
            addCriterion("grain_kind is null");
            return (Criteria) this;
        }

        public Criteria andGrainKindIsNotNull() {
            addCriterion("grain_kind is not null");
            return (Criteria) this;
        }

        public Criteria andGrainKindEqualTo(Integer value) {
            addCriterion("grain_kind =", value, "grainKind");
            return (Criteria) this;
        }

        public Criteria andGrainKindNotEqualTo(Integer value) {
            addCriterion("grain_kind <>", value, "grainKind");
            return (Criteria) this;
        }

        public Criteria andGrainKindGreaterThan(Integer value) {
            addCriterion("grain_kind >", value, "grainKind");
            return (Criteria) this;
        }

        public Criteria andGrainKindGreaterThanOrEqualTo(Integer value) {
            addCriterion("grain_kind >=", value, "grainKind");
            return (Criteria) this;
        }

        public Criteria andGrainKindLessThan(Integer value) {
            addCriterion("grain_kind <", value, "grainKind");
            return (Criteria) this;
        }

        public Criteria andGrainKindLessThanOrEqualTo(Integer value) {
            addCriterion("grain_kind <=", value, "grainKind");
            return (Criteria) this;
        }

        public Criteria andGrainKindIn(List<Integer> values) {
            addCriterion("grain_kind in", values, "grainKind");
            return (Criteria) this;
        }

        public Criteria andGrainKindNotIn(List<Integer> values) {
            addCriterion("grain_kind not in", values, "grainKind");
            return (Criteria) this;
        }

        public Criteria andGrainKindBetween(Integer value1, Integer value2) {
            addCriterion("grain_kind between", value1, value2, "grainKind");
            return (Criteria) this;
        }

        public Criteria andGrainKindNotBetween(Integer value1, Integer value2) {
            addCriterion("grain_kind not between", value1, value2, "grainKind");
            return (Criteria) this;
        }

        public Criteria andGrainCountIsNull() {
            addCriterion("grain_count is null");
            return (Criteria) this;
        }

        public Criteria andGrainCountIsNotNull() {
            addCriterion("grain_count is not null");
            return (Criteria) this;
        }

        public Criteria andGrainCountEqualTo(BigDecimal value) {
            addCriterion("grain_count =", value, "grainCount");
            return (Criteria) this;
        }

        public Criteria andGrainCountNotEqualTo(BigDecimal value) {
            addCriterion("grain_count <>", value, "grainCount");
            return (Criteria) this;
        }

        public Criteria andGrainCountGreaterThan(BigDecimal value) {
            addCriterion("grain_count >", value, "grainCount");
            return (Criteria) this;
        }

        public Criteria andGrainCountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("grain_count >=", value, "grainCount");
            return (Criteria) this;
        }

        public Criteria andGrainCountLessThan(BigDecimal value) {
            addCriterion("grain_count <", value, "grainCount");
            return (Criteria) this;
        }

        public Criteria andGrainCountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("grain_count <=", value, "grainCount");
            return (Criteria) this;
        }

        public Criteria andGrainCountIn(List<BigDecimal> values) {
            addCriterion("grain_count in", values, "grainCount");
            return (Criteria) this;
        }

        public Criteria andGrainCountNotIn(List<BigDecimal> values) {
            addCriterion("grain_count not in", values, "grainCount");
            return (Criteria) this;
        }

        public Criteria andGrainCountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("grain_count between", value1, value2, "grainCount");
            return (Criteria) this;
        }

        public Criteria andGrainCountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("grain_count not between", value1, value2, "grainCount");
            return (Criteria) this;
        }

        public Criteria andGrainStorageTimeIsNull() {
            addCriterion("grain_storage_time is null");
            return (Criteria) this;
        }

        public Criteria andGrainStorageTimeIsNotNull() {
            addCriterion("grain_storage_time is not null");
            return (Criteria) this;
        }

        public Criteria andGrainStorageTimeEqualTo(Date value) {
            addCriterion("grain_storage_time =", value, "grainStorageTime");
            return (Criteria) this;
        }

        public Criteria andGrainStorageTimeNotEqualTo(Date value) {
            addCriterion("grain_storage_time <>", value, "grainStorageTime");
            return (Criteria) this;
        }

        public Criteria andGrainStorageTimeGreaterThan(Date value) {
            addCriterion("grain_storage_time >", value, "grainStorageTime");
            return (Criteria) this;
        }

        public Criteria andGrainStorageTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("grain_storage_time >=", value, "grainStorageTime");
            return (Criteria) this;
        }

        public Criteria andGrainStorageTimeLessThan(Date value) {
            addCriterion("grain_storage_time <", value, "grainStorageTime");
            return (Criteria) this;
        }

        public Criteria andGrainStorageTimeLessThanOrEqualTo(Date value) {
            addCriterion("grain_storage_time <=", value, "grainStorageTime");
            return (Criteria) this;
        }

        public Criteria andGrainStorageTimeIn(List<Date> values) {
            addCriterion("grain_storage_time in", values, "grainStorageTime");
            return (Criteria) this;
        }

        public Criteria andGrainStorageTimeNotIn(List<Date> values) {
            addCriterion("grain_storage_time not in", values, "grainStorageTime");
            return (Criteria) this;
        }

        public Criteria andGrainStorageTimeBetween(Date value1, Date value2) {
            addCriterion("grain_storage_time between", value1, value2, "grainStorageTime");
            return (Criteria) this;
        }

        public Criteria andGrainStorageTimeNotBetween(Date value1, Date value2) {
            addCriterion("grain_storage_time not between", value1, value2, "grainStorageTime");
            return (Criteria) this;
        }

        public Criteria andFumigationTypeIsNull() {
            addCriterion("fumigation_type is null");
            return (Criteria) this;
        }

        public Criteria andFumigationTypeIsNotNull() {
            addCriterion("fumigation_type is not null");
            return (Criteria) this;
        }

        public Criteria andFumigationTypeEqualTo(Integer value) {
            addCriterion("fumigation_type =", value, "fumigationType");
            return (Criteria) this;
        }

        public Criteria andFumigationTypeNotEqualTo(Integer value) {
            addCriterion("fumigation_type <>", value, "fumigationType");
            return (Criteria) this;
        }

        public Criteria andFumigationTypeGreaterThan(Integer value) {
            addCriterion("fumigation_type >", value, "fumigationType");
            return (Criteria) this;
        }

        public Criteria andFumigationTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("fumigation_type >=", value, "fumigationType");
            return (Criteria) this;
        }

        public Criteria andFumigationTypeLessThan(Integer value) {
            addCriterion("fumigation_type <", value, "fumigationType");
            return (Criteria) this;
        }

        public Criteria andFumigationTypeLessThanOrEqualTo(Integer value) {
            addCriterion("fumigation_type <=", value, "fumigationType");
            return (Criteria) this;
        }

        public Criteria andFumigationTypeIn(List<Integer> values) {
            addCriterion("fumigation_type in", values, "fumigationType");
            return (Criteria) this;
        }

        public Criteria andFumigationTypeNotIn(List<Integer> values) {
            addCriterion("fumigation_type not in", values, "fumigationType");
            return (Criteria) this;
        }

        public Criteria andFumigationTypeBetween(Integer value1, Integer value2) {
            addCriterion("fumigation_type between", value1, value2, "fumigationType");
            return (Criteria) this;
        }

        public Criteria andFumigationTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("fumigation_type not between", value1, value2, "fumigationType");
            return (Criteria) this;
        }

        public Criteria andFumigationNumberIsNull() {
            addCriterion("fumigation_number is null");
            return (Criteria) this;
        }

        public Criteria andFumigationNumberIsNotNull() {
            addCriterion("fumigation_number is not null");
            return (Criteria) this;
        }

        public Criteria andFumigationNumberEqualTo(Integer value) {
            addCriterion("fumigation_number =", value, "fumigationNumber");
            return (Criteria) this;
        }

        public Criteria andFumigationNumberNotEqualTo(Integer value) {
            addCriterion("fumigation_number <>", value, "fumigationNumber");
            return (Criteria) this;
        }

        public Criteria andFumigationNumberGreaterThan(Integer value) {
            addCriterion("fumigation_number >", value, "fumigationNumber");
            return (Criteria) this;
        }

        public Criteria andFumigationNumberGreaterThanOrEqualTo(Integer value) {
            addCriterion("fumigation_number >=", value, "fumigationNumber");
            return (Criteria) this;
        }

        public Criteria andFumigationNumberLessThan(Integer value) {
            addCriterion("fumigation_number <", value, "fumigationNumber");
            return (Criteria) this;
        }

        public Criteria andFumigationNumberLessThanOrEqualTo(Integer value) {
            addCriterion("fumigation_number <=", value, "fumigationNumber");
            return (Criteria) this;
        }

        public Criteria andFumigationNumberIn(List<Integer> values) {
            addCriterion("fumigation_number in", values, "fumigationNumber");
            return (Criteria) this;
        }

        public Criteria andFumigationNumberNotIn(List<Integer> values) {
            addCriterion("fumigation_number not in", values, "fumigationNumber");
            return (Criteria) this;
        }

        public Criteria andFumigationNumberBetween(Integer value1, Integer value2) {
            addCriterion("fumigation_number between", value1, value2, "fumigationNumber");
            return (Criteria) this;
        }

        public Criteria andFumigationNumberNotBetween(Integer value1, Integer value2) {
            addCriterion("fumigation_number not between", value1, value2, "fumigationNumber");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandIsNull() {
            addCriterion("fumigation_command is null");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandIsNotNull() {
            addCriterion("fumigation_command is not null");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandEqualTo(String value) {
            addCriterion("fumigation_command =", value, "fumigationCommand");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandNotEqualTo(String value) {
            addCriterion("fumigation_command <>", value, "fumigationCommand");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandGreaterThan(String value) {
            addCriterion("fumigation_command >", value, "fumigationCommand");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandGreaterThanOrEqualTo(String value) {
            addCriterion("fumigation_command >=", value, "fumigationCommand");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandLessThan(String value) {
            addCriterion("fumigation_command <", value, "fumigationCommand");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandLessThanOrEqualTo(String value) {
            addCriterion("fumigation_command <=", value, "fumigationCommand");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandLike(String value) {
            addCriterion("fumigation_command like", value, "fumigationCommand");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandNotLike(String value) {
            addCriterion("fumigation_command not like", value, "fumigationCommand");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandIn(List<String> values) {
            addCriterion("fumigation_command in", values, "fumigationCommand");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandNotIn(List<String> values) {
            addCriterion("fumigation_command not in", values, "fumigationCommand");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandBetween(String value1, String value2) {
            addCriterion("fumigation_command between", value1, value2, "fumigationCommand");
            return (Criteria) this;
        }

        public Criteria andFumigationCommandNotBetween(String value1, String value2) {
            addCriterion("fumigation_command not between", value1, value2, "fumigationCommand");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationIsNull() {
            addCriterion("fumigation_operation is null");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationIsNotNull() {
            addCriterion("fumigation_operation is not null");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationEqualTo(String value) {
            addCriterion("fumigation_operation =", value, "fumigationOperation");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationNotEqualTo(String value) {
            addCriterion("fumigation_operation <>", value, "fumigationOperation");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationGreaterThan(String value) {
            addCriterion("fumigation_operation >", value, "fumigationOperation");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationGreaterThanOrEqualTo(String value) {
            addCriterion("fumigation_operation >=", value, "fumigationOperation");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationLessThan(String value) {
            addCriterion("fumigation_operation <", value, "fumigationOperation");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationLessThanOrEqualTo(String value) {
            addCriterion("fumigation_operation <=", value, "fumigationOperation");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationLike(String value) {
            addCriterion("fumigation_operation like", value, "fumigationOperation");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationNotLike(String value) {
            addCriterion("fumigation_operation not like", value, "fumigationOperation");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationIn(List<String> values) {
            addCriterion("fumigation_operation in", values, "fumigationOperation");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationNotIn(List<String> values) {
            addCriterion("fumigation_operation not in", values, "fumigationOperation");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationBetween(String value1, String value2) {
            addCriterion("fumigation_operation between", value1, value2, "fumigationOperation");
            return (Criteria) this;
        }

        public Criteria andFumigationOperationNotBetween(String value1, String value2) {
            addCriterion("fumigation_operation not between", value1, value2, "fumigationOperation");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveIsNull() {
            addCriterion("fumiagtion_protective is null");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveIsNotNull() {
            addCriterion("fumiagtion_protective is not null");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveEqualTo(String value) {
            addCriterion("fumiagtion_protective =", value, "fumiagtionProtective");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveNotEqualTo(String value) {
            addCriterion("fumiagtion_protective <>", value, "fumiagtionProtective");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveGreaterThan(String value) {
            addCriterion("fumiagtion_protective >", value, "fumiagtionProtective");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveGreaterThanOrEqualTo(String value) {
            addCriterion("fumiagtion_protective >=", value, "fumiagtionProtective");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveLessThan(String value) {
            addCriterion("fumiagtion_protective <", value, "fumiagtionProtective");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveLessThanOrEqualTo(String value) {
            addCriterion("fumiagtion_protective <=", value, "fumiagtionProtective");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveLike(String value) {
            addCriterion("fumiagtion_protective like", value, "fumiagtionProtective");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveNotLike(String value) {
            addCriterion("fumiagtion_protective not like", value, "fumiagtionProtective");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveIn(List<String> values) {
            addCriterion("fumiagtion_protective in", values, "fumiagtionProtective");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveNotIn(List<String> values) {
            addCriterion("fumiagtion_protective not in", values, "fumiagtionProtective");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveBetween(String value1, String value2) {
            addCriterion("fumiagtion_protective between", value1, value2, "fumiagtionProtective");
            return (Criteria) this;
        }

        public Criteria andFumiagtionProtectiveNotBetween(String value1, String value2) {
            addCriterion("fumiagtion_protective not between", value1, value2, "fumiagtionProtective");
            return (Criteria) this;
        }

        public Criteria andExpectedIsNull() {
            addCriterion("expected is null");
            return (Criteria) this;
        }

        public Criteria andExpectedIsNotNull() {
            addCriterion("expected is not null");
            return (Criteria) this;
        }

        public Criteria andExpectedEqualTo(String value) {
            addCriterion("expected =", value, "expected");
            return (Criteria) this;
        }

        public Criteria andExpectedNotEqualTo(String value) {
            addCriterion("expected <>", value, "expected");
            return (Criteria) this;
        }

        public Criteria andExpectedGreaterThan(String value) {
            addCriterion("expected >", value, "expected");
            return (Criteria) this;
        }

        public Criteria andExpectedGreaterThanOrEqualTo(String value) {
            addCriterion("expected >=", value, "expected");
            return (Criteria) this;
        }

        public Criteria andExpectedLessThan(String value) {
            addCriterion("expected <", value, "expected");
            return (Criteria) this;
        }

        public Criteria andExpectedLessThanOrEqualTo(String value) {
            addCriterion("expected <=", value, "expected");
            return (Criteria) this;
        }

        public Criteria andExpectedLike(String value) {
            addCriterion("expected like", value, "expected");
            return (Criteria) this;
        }

        public Criteria andExpectedNotLike(String value) {
            addCriterion("expected not like", value, "expected");
            return (Criteria) this;
        }

        public Criteria andExpectedIn(List<String> values) {
            addCriterion("expected in", values, "expected");
            return (Criteria) this;
        }

        public Criteria andExpectedNotIn(List<String> values) {
            addCriterion("expected not in", values, "expected");
            return (Criteria) this;
        }

        public Criteria andExpectedBetween(String value1, String value2) {
            addCriterion("expected between", value1, value2, "expected");
            return (Criteria) this;
        }

        public Criteria andExpectedNotBetween(String value1, String value2) {
            addCriterion("expected not between", value1, value2, "expected");
            return (Criteria) this;
        }

        public Criteria andPointsWorkIsNull() {
            addCriterion("points_work is null");
            return (Criteria) this;
        }

        public Criteria andPointsWorkIsNotNull() {
            addCriterion("points_work is not null");
            return (Criteria) this;
        }

        public Criteria andPointsWorkEqualTo(String value) {
            addCriterion("points_work =", value, "pointsWork");
            return (Criteria) this;
        }

        public Criteria andPointsWorkNotEqualTo(String value) {
            addCriterion("points_work <>", value, "pointsWork");
            return (Criteria) this;
        }

        public Criteria andPointsWorkGreaterThan(String value) {
            addCriterion("points_work >", value, "pointsWork");
            return (Criteria) this;
        }

        public Criteria andPointsWorkGreaterThanOrEqualTo(String value) {
            addCriterion("points_work >=", value, "pointsWork");
            return (Criteria) this;
        }

        public Criteria andPointsWorkLessThan(String value) {
            addCriterion("points_work <", value, "pointsWork");
            return (Criteria) this;
        }

        public Criteria andPointsWorkLessThanOrEqualTo(String value) {
            addCriterion("points_work <=", value, "pointsWork");
            return (Criteria) this;
        }

        public Criteria andPointsWorkLike(String value) {
            addCriterion("points_work like", value, "pointsWork");
            return (Criteria) this;
        }

        public Criteria andPointsWorkNotLike(String value) {
            addCriterion("points_work not like", value, "pointsWork");
            return (Criteria) this;
        }

        public Criteria andPointsWorkIn(List<String> values) {
            addCriterion("points_work in", values, "pointsWork");
            return (Criteria) this;
        }

        public Criteria andPointsWorkNotIn(List<String> values) {
            addCriterion("points_work not in", values, "pointsWork");
            return (Criteria) this;
        }

        public Criteria andPointsWorkBetween(String value1, String value2) {
            addCriterion("points_work between", value1, value2, "pointsWork");
            return (Criteria) this;
        }

        public Criteria andPointsWorkNotBetween(String value1, String value2) {
            addCriterion("points_work not between", value1, value2, "pointsWork");
            return (Criteria) this;
        }

        public Criteria andNoteIsNull() {
            addCriterion("note is null");
            return (Criteria) this;
        }

        public Criteria andNoteIsNotNull() {
            addCriterion("note is not null");
            return (Criteria) this;
        }

        public Criteria andNoteEqualTo(String value) {
            addCriterion("note =", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteNotEqualTo(String value) {
            addCriterion("note <>", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteGreaterThan(String value) {
            addCriterion("note >", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteGreaterThanOrEqualTo(String value) {
            addCriterion("note >=", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteLessThan(String value) {
            addCriterion("note <", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteLessThanOrEqualTo(String value) {
            addCriterion("note <=", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteLike(String value) {
            addCriterion("note like", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteNotLike(String value) {
            addCriterion("note not like", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteIn(List<String> values) {
            addCriterion("note in", values, "note");
            return (Criteria) this;
        }

        public Criteria andNoteNotIn(List<String> values) {
            addCriterion("note not in", values, "note");
            return (Criteria) this;
        }

        public Criteria andNoteBetween(String value1, String value2) {
            addCriterion("note between", value1, value2, "note");
            return (Criteria) this;
        }

        public Criteria andNoteNotBetween(String value1, String value2) {
            addCriterion("note not between", value1, value2, "note");
            return (Criteria) this;
        }

        public Criteria andStateIsNull() {
            addCriterion("state is null");
            return (Criteria) this;
        }

        public Criteria andStateIsNotNull() {
            addCriterion("state is not null");
            return (Criteria) this;
        }

        public Criteria andStateEqualTo(Integer value) {
            addCriterion("state =", value, "state");
            return (Criteria) this;
        }

        public Criteria andStateNotEqualTo(Integer value) {
            addCriterion("state <>", value, "state");
            return (Criteria) this;
        }

        public Criteria andStateGreaterThan(Integer value) {
            addCriterion("state >", value, "state");
            return (Criteria) this;
        }

        public Criteria andStateGreaterThanOrEqualTo(Integer value) {
            addCriterion("state >=", value, "state");
            return (Criteria) this;
        }

        public Criteria andStateLessThan(Integer value) {
            addCriterion("state <", value, "state");
            return (Criteria) this;
        }

        public Criteria andStateLessThanOrEqualTo(Integer value) {
            addCriterion("state <=", value, "state");
            return (Criteria) this;
        }

        public Criteria andStateIn(List<Integer> values) {
            addCriterion("state in", values, "state");
            return (Criteria) this;
        }

        public Criteria andStateNotIn(List<Integer> values) {
            addCriterion("state not in", values, "state");
            return (Criteria) this;
        }

        public Criteria andStateBetween(Integer value1, Integer value2) {
            addCriterion("state between", value1, value2, "state");
            return (Criteria) this;
        }

        public Criteria andStateNotBetween(Integer value1, Integer value2) {
            addCriterion("state not between", value1, value2, "state");
            return (Criteria) this;
        }

        public Criteria andCreaterIsNull() {
            addCriterion("creater is null");
            return (Criteria) this;
        }

        public Criteria andCreaterIsNotNull() {
            addCriterion("creater is not null");
            return (Criteria) this;
        }

        public Criteria andCreaterEqualTo(String value) {
            addCriterion("creater =", value, "creater");
            return (Criteria) this;
        }

        public Criteria andCreaterNotEqualTo(String value) {
            addCriterion("creater <>", value, "creater");
            return (Criteria) this;
        }

        public Criteria andCreaterGreaterThan(String value) {
            addCriterion("creater >", value, "creater");
            return (Criteria) this;
        }

        public Criteria andCreaterGreaterThanOrEqualTo(String value) {
            addCriterion("creater >=", value, "creater");
            return (Criteria) this;
        }

        public Criteria andCreaterLessThan(String value) {
            addCriterion("creater <", value, "creater");
            return (Criteria) this;
        }

        public Criteria andCreaterLessThanOrEqualTo(String value) {
            addCriterion("creater <=", value, "creater");
            return (Criteria) this;
        }

        public Criteria andCreaterLike(String value) {
            addCriterion("creater like", value, "creater");
            return (Criteria) this;
        }

        public Criteria andCreaterNotLike(String value) {
            addCriterion("creater not like", value, "creater");
            return (Criteria) this;
        }

        public Criteria andCreaterIn(List<String> values) {
            addCriterion("creater in", values, "creater");
            return (Criteria) this;
        }

        public Criteria andCreaterNotIn(List<String> values) {
            addCriterion("creater not in", values, "creater");
            return (Criteria) this;
        }

        public Criteria andCreaterBetween(String value1, String value2) {
            addCriterion("creater between", value1, value2, "creater");
            return (Criteria) this;
        }

        public Criteria andCreaterNotBetween(String value1, String value2) {
            addCriterion("creater not between", value1, value2, "creater");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleIsNull() {
            addCriterion("approve_people is null");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleIsNotNull() {
            addCriterion("approve_people is not null");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleEqualTo(String value) {
            addCriterion("approve_people =", value, "approvePeople");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleNotEqualTo(String value) {
            addCriterion("approve_people <>", value, "approvePeople");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleGreaterThan(String value) {
            addCriterion("approve_people >", value, "approvePeople");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleGreaterThanOrEqualTo(String value) {
            addCriterion("approve_people >=", value, "approvePeople");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleLessThan(String value) {
            addCriterion("approve_people <", value, "approvePeople");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleLessThanOrEqualTo(String value) {
            addCriterion("approve_people <=", value, "approvePeople");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleLike(String value) {
            addCriterion("approve_people like", value, "approvePeople");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleNotLike(String value) {
            addCriterion("approve_people not like", value, "approvePeople");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleIn(List<String> values) {
            addCriterion("approve_people in", values, "approvePeople");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleNotIn(List<String> values) {
            addCriterion("approve_people not in", values, "approvePeople");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleBetween(String value1, String value2) {
            addCriterion("approve_people between", value1, value2, "approvePeople");
            return (Criteria) this;
        }

        public Criteria andApprovePeopleNotBetween(String value1, String value2) {
            addCriterion("approve_people not between", value1, value2, "approvePeople");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentIsNull() {
            addCriterion("approve_department is null");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentIsNotNull() {
            addCriterion("approve_department is not null");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentEqualTo(String value) {
            addCriterion("approve_department =", value, "approveDepartment");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentNotEqualTo(String value) {
            addCriterion("approve_department <>", value, "approveDepartment");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentGreaterThan(String value) {
            addCriterion("approve_department >", value, "approveDepartment");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentGreaterThanOrEqualTo(String value) {
            addCriterion("approve_department >=", value, "approveDepartment");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentLessThan(String value) {
            addCriterion("approve_department <", value, "approveDepartment");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentLessThanOrEqualTo(String value) {
            addCriterion("approve_department <=", value, "approveDepartment");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentLike(String value) {
            addCriterion("approve_department like", value, "approveDepartment");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentNotLike(String value) {
            addCriterion("approve_department not like", value, "approveDepartment");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentIn(List<String> values) {
            addCriterion("approve_department in", values, "approveDepartment");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentNotIn(List<String> values) {
            addCriterion("approve_department not in", values, "approveDepartment");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentBetween(String value1, String value2) {
            addCriterion("approve_department between", value1, value2, "approveDepartment");
            return (Criteria) this;
        }

        public Criteria andApproveDepartmentNotBetween(String value1, String value2) {
            addCriterion("approve_department not between", value1, value2, "approveDepartment");
            return (Criteria) this;
        }

        public Criteria andApproveNoteIsNull() {
            addCriterion("approve_note is null");
            return (Criteria) this;
        }

        public Criteria andApproveNoteIsNotNull() {
            addCriterion("approve_note is not null");
            return (Criteria) this;
        }

        public Criteria andApproveNoteEqualTo(String value) {
            addCriterion("approve_note =", value, "approveNote");
            return (Criteria) this;
        }

        public Criteria andApproveNoteNotEqualTo(String value) {
            addCriterion("approve_note <>", value, "approveNote");
            return (Criteria) this;
        }

        public Criteria andApproveNoteGreaterThan(String value) {
            addCriterion("approve_note >", value, "approveNote");
            return (Criteria) this;
        }

        public Criteria andApproveNoteGreaterThanOrEqualTo(String value) {
            addCriterion("approve_note >=", value, "approveNote");
            return (Criteria) this;
        }

        public Criteria andApproveNoteLessThan(String value) {
            addCriterion("approve_note <", value, "approveNote");
            return (Criteria) this;
        }

        public Criteria andApproveNoteLessThanOrEqualTo(String value) {
            addCriterion("approve_note <=", value, "approveNote");
            return (Criteria) this;
        }

        public Criteria andApproveNoteLike(String value) {
            addCriterion("approve_note like", value, "approveNote");
            return (Criteria) this;
        }

        public Criteria andApproveNoteNotLike(String value) {
            addCriterion("approve_note not like", value, "approveNote");
            return (Criteria) this;
        }

        public Criteria andApproveNoteIn(List<String> values) {
            addCriterion("approve_note in", values, "approveNote");
            return (Criteria) this;
        }

        public Criteria andApproveNoteNotIn(List<String> values) {
            addCriterion("approve_note not in", values, "approveNote");
            return (Criteria) this;
        }

        public Criteria andApproveNoteBetween(String value1, String value2) {
            addCriterion("approve_note between", value1, value2, "approveNote");
            return (Criteria) this;
        }

        public Criteria andApproveNoteNotBetween(String value1, String value2) {
            addCriterion("approve_note not between", value1, value2, "approveNote");
            return (Criteria) this;
        }

        public Criteria andApproveTimeIsNull() {
            addCriterion("approve_time is null");
            return (Criteria) this;
        }

        public Criteria andApproveTimeIsNotNull() {
            addCriterion("approve_time is not null");
            return (Criteria) this;
        }

        public Criteria andApproveTimeEqualTo(Date value) {
            addCriterion("approve_time =", value, "approveTime");
            return (Criteria) this;
        }

        public Criteria andApproveTimeNotEqualTo(Date value) {
            addCriterion("approve_time <>", value, "approveTime");
            return (Criteria) this;
        }

        public Criteria andApproveTimeGreaterThan(Date value) {
            addCriterion("approve_time >", value, "approveTime");
            return (Criteria) this;
        }

        public Criteria andApproveTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("approve_time >=", value, "approveTime");
            return (Criteria) this;
        }

        public Criteria andApproveTimeLessThan(Date value) {
            addCriterion("approve_time <", value, "approveTime");
            return (Criteria) this;
        }

        public Criteria andApproveTimeLessThanOrEqualTo(Date value) {
            addCriterion("approve_time <=", value, "approveTime");
            return (Criteria) this;
        }

        public Criteria andApproveTimeIn(List<Date> values) {
            addCriterion("approve_time in", values, "approveTime");
            return (Criteria) this;
        }

        public Criteria andApproveTimeNotIn(List<Date> values) {
            addCriterion("approve_time not in", values, "approveTime");
            return (Criteria) this;
        }

        public Criteria andApproveTimeBetween(Date value1, Date value2) {
            addCriterion("approve_time between", value1, value2, "approveTime");
            return (Criteria) this;
        }

        public Criteria andApproveTimeNotBetween(Date value1, Date value2) {
            addCriterion("approve_time not between", value1, value2, "approveTime");
            return (Criteria) this;
        }

        public Criteria andDeleteStateIsNull() {
            addCriterion("delete_state is null");
            return (Criteria) this;
        }

        public Criteria andDeleteStateIsNotNull() {
            addCriterion("delete_state is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteStateEqualTo(String value) {
            addCriterion("delete_state =", value, "deleteState");
            return (Criteria) this;
        }

        public Criteria andDeleteStateNotEqualTo(String value) {
            addCriterion("delete_state <>", value, "deleteState");
            return (Criteria) this;
        }

        public Criteria andDeleteStateGreaterThan(String value) {
            addCriterion("delete_state >", value, "deleteState");
            return (Criteria) this;
        }

        public Criteria andDeleteStateGreaterThanOrEqualTo(String value) {
            addCriterion("delete_state >=", value, "deleteState");
            return (Criteria) this;
        }

        public Criteria andDeleteStateLessThan(String value) {
            addCriterion("delete_state <", value, "deleteState");
            return (Criteria) this;
        }

        public Criteria andDeleteStateLessThanOrEqualTo(String value) {
            addCriterion("delete_state <=", value, "deleteState");
            return (Criteria) this;
        }

        public Criteria andDeleteStateLike(String value) {
            addCriterion("delete_state like", value, "deleteState");
            return (Criteria) this;
        }

        public Criteria andDeleteStateNotLike(String value) {
            addCriterion("delete_state not like", value, "deleteState");
            return (Criteria) this;
        }

        public Criteria andDeleteStateIn(List<String> values) {
            addCriterion("delete_state in", values, "deleteState");
            return (Criteria) this;
        }

        public Criteria andDeleteStateNotIn(List<String> values) {
            addCriterion("delete_state not in", values, "deleteState");
            return (Criteria) this;
        }

        public Criteria andDeleteStateBetween(String value1, String value2) {
            addCriterion("delete_state between", value1, value2, "deleteState");
            return (Criteria) this;
        }

        public Criteria andDeleteStateNotBetween(String value1, String value2) {
            addCriterion("delete_state not between", value1, value2, "deleteState");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andFumigationFrequencyIsNull() {
            addCriterion("fumigation_frequency is null");
            return (Criteria) this;
        }

        public Criteria andFumigationFrequencyIsNotNull() {
            addCriterion("fumigation_frequency is not null");
            return (Criteria) this;
        }

        public Criteria andFumigationFrequencyEqualTo(Integer value) {
            addCriterion("fumigation_frequency =", value, "fumigationFrequency");
            return (Criteria) this;
        }

        public Criteria andFumigationFrequencyNotEqualTo(Integer value) {
            addCriterion("fumigation_frequency <>", value, "fumigationFrequency");
            return (Criteria) this;
        }

        public Criteria andFumigationFrequencyGreaterThan(Integer value) {
            addCriterion("fumigation_frequency >", value, "fumigationFrequency");
            return (Criteria) this;
        }

        public Criteria andFumigationFrequencyGreaterThanOrEqualTo(Integer value) {
            addCriterion("fumigation_frequency >=", value, "fumigationFrequency");
            return (Criteria) this;
        }

        public Criteria andFumigationFrequencyLessThan(Integer value) {
            addCriterion("fumigation_frequency <", value, "fumigationFrequency");
            return (Criteria) this;
        }

        public Criteria andFumigationFrequencyLessThanOrEqualTo(Integer value) {
            addCriterion("fumigation_frequency <=", value, "fumigationFrequency");
            return (Criteria) this;
        }

        public Criteria andFumigationFrequencyIn(List<Integer> values) {
            addCriterion("fumigation_frequency in", values, "fumigationFrequency");
            return (Criteria) this;
        }

        public Criteria andFumigationFrequencyNotIn(List<Integer> values) {
            addCriterion("fumigation_frequency not in", values, "fumigationFrequency");
            return (Criteria) this;
        }

        public Criteria andFumigationFrequencyBetween(Integer value1, Integer value2) {
            addCriterion("fumigation_frequency between", value1, value2, "fumigationFrequency");
            return (Criteria) this;
        }

        public Criteria andFumigationFrequencyNotBetween(Integer value1, Integer value2) {
            addCriterion("fumigation_frequency not between", value1, value2, "fumigationFrequency");
            return (Criteria) this;
        }

        public Criteria andCgxzfsIsNull() {
            addCriterion("cgxzfs is null");
            return (Criteria) this;
        }

        public Criteria andCgxzfsIsNotNull() {
            addCriterion("cgxzfs is not null");
            return (Criteria) this;
        }

        public Criteria andCgxzfsEqualTo(String value) {
            addCriterion("cgxzfs =", value, "cgxzfs");
            return (Criteria) this;
        }

        public Criteria andCgxzfsNotEqualTo(String value) {
            addCriterion("cgxzfs <>", value, "cgxzfs");
            return (Criteria) this;
        }

        public Criteria andCgxzfsGreaterThan(String value) {
            addCriterion("cgxzfs >", value, "cgxzfs");
            return (Criteria) this;
        }

        public Criteria andCgxzfsGreaterThanOrEqualTo(String value) {
            addCriterion("cgxzfs >=", value, "cgxzfs");
            return (Criteria) this;
        }

        public Criteria andCgxzfsLessThan(String value) {
            addCriterion("cgxzfs <", value, "cgxzfs");
            return (Criteria) this;
        }

        public Criteria andCgxzfsLessThanOrEqualTo(String value) {
            addCriterion("cgxzfs <=", value, "cgxzfs");
            return (Criteria) this;
        }

        public Criteria andCgxzfsLike(String value) {
            addCriterion("cgxzfs like", value, "cgxzfs");
            return (Criteria) this;
        }

        public Criteria andCgxzfsNotLike(String value) {
            addCriterion("cgxzfs not like", value, "cgxzfs");
            return (Criteria) this;
        }

        public Criteria andCgxzfsIn(List<String> values) {
            addCriterion("cgxzfs in", values, "cgxzfs");
            return (Criteria) this;
        }

        public Criteria andCgxzfsNotIn(List<String> values) {
            addCriterion("cgxzfs not in", values, "cgxzfs");
            return (Criteria) this;
        }

        public Criteria andCgxzfsBetween(String value1, String value2) {
            addCriterion("cgxzfs between", value1, value2, "cgxzfs");
            return (Criteria) this;
        }

        public Criteria andCgxzfsNotBetween(String value1, String value2) {
            addCriterion("cgxzfs not between", value1, value2, "cgxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzfsIsNull() {
            addCriterion("hlxzfs is null");
            return (Criteria) this;
        }

        public Criteria andHlxzfsIsNotNull() {
            addCriterion("hlxzfs is not null");
            return (Criteria) this;
        }

        public Criteria andHlxzfsEqualTo(String value) {
            addCriterion("hlxzfs =", value, "hlxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzfsNotEqualTo(String value) {
            addCriterion("hlxzfs <>", value, "hlxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzfsGreaterThan(String value) {
            addCriterion("hlxzfs >", value, "hlxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzfsGreaterThanOrEqualTo(String value) {
            addCriterion("hlxzfs >=", value, "hlxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzfsLessThan(String value) {
            addCriterion("hlxzfs <", value, "hlxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzfsLessThanOrEqualTo(String value) {
            addCriterion("hlxzfs <=", value, "hlxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzfsLike(String value) {
            addCriterion("hlxzfs like", value, "hlxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzfsNotLike(String value) {
            addCriterion("hlxzfs not like", value, "hlxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzfsIn(List<String> values) {
            addCriterion("hlxzfs in", values, "hlxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzfsNotIn(List<String> values) {
            addCriterion("hlxzfs not in", values, "hlxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzfsBetween(String value1, String value2) {
            addCriterion("hlxzfs between", value1, value2, "hlxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzfsNotBetween(String value1, String value2) {
            addCriterion("hlxzfs not between", value1, value2, "hlxzfs");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhIsNull() {
            addCriterion("hlxzynhljsjh is null");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhIsNotNull() {
            addCriterion("hlxzynhljsjh is not null");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhEqualTo(String value) {
            addCriterion("hlxzynhljsjh =", value, "hlxzynhljsjh");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhNotEqualTo(String value) {
            addCriterion("hlxzynhljsjh <>", value, "hlxzynhljsjh");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhGreaterThan(String value) {
            addCriterion("hlxzynhljsjh >", value, "hlxzynhljsjh");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhGreaterThanOrEqualTo(String value) {
            addCriterion("hlxzynhljsjh >=", value, "hlxzynhljsjh");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhLessThan(String value) {
            addCriterion("hlxzynhljsjh <", value, "hlxzynhljsjh");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhLessThanOrEqualTo(String value) {
            addCriterion("hlxzynhljsjh <=", value, "hlxzynhljsjh");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhLike(String value) {
            addCriterion("hlxzynhljsjh like", value, "hlxzynhljsjh");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhNotLike(String value) {
            addCriterion("hlxzynhljsjh not like", value, "hlxzynhljsjh");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhIn(List<String> values) {
            addCriterion("hlxzynhljsjh in", values, "hlxzynhljsjh");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhNotIn(List<String> values) {
            addCriterion("hlxzynhljsjh not in", values, "hlxzynhljsjh");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhBetween(String value1, String value2) {
            addCriterion("hlxzynhljsjh between", value1, value2, "hlxzynhljsjh");
            return (Criteria) this;
        }

        public Criteria andHlxzynhljsjhNotBetween(String value1, String value2) {
            addCriterion("hlxzynhljsjh not between", value1, value2, "hlxzynhljsjh");
            return (Criteria) this;
        }

        public Criteria andXzfazdIsNull() {
            addCriterion("xzfazd is null");
            return (Criteria) this;
        }

        public Criteria andXzfazdIsNotNull() {
            addCriterion("xzfazd is not null");
            return (Criteria) this;
        }

        public Criteria andXzfazdEqualTo(String value) {
            addCriterion("xzfazd =", value, "xzfazd");
            return (Criteria) this;
        }

        public Criteria andXzfazdNotEqualTo(String value) {
            addCriterion("xzfazd <>", value, "xzfazd");
            return (Criteria) this;
        }

        public Criteria andXzfazdGreaterThan(String value) {
            addCriterion("xzfazd >", value, "xzfazd");
            return (Criteria) this;
        }

        public Criteria andXzfazdGreaterThanOrEqualTo(String value) {
            addCriterion("xzfazd >=", value, "xzfazd");
            return (Criteria) this;
        }

        public Criteria andXzfazdLessThan(String value) {
            addCriterion("xzfazd <", value, "xzfazd");
            return (Criteria) this;
        }

        public Criteria andXzfazdLessThanOrEqualTo(String value) {
            addCriterion("xzfazd <=", value, "xzfazd");
            return (Criteria) this;
        }

        public Criteria andXzfazdLike(String value) {
            addCriterion("xzfazd like", value, "xzfazd");
            return (Criteria) this;
        }

        public Criteria andXzfazdNotLike(String value) {
            addCriterion("xzfazd not like", value, "xzfazd");
            return (Criteria) this;
        }

        public Criteria andXzfazdIn(List<String> values) {
            addCriterion("xzfazd in", values, "xzfazd");
            return (Criteria) this;
        }

        public Criteria andXzfazdNotIn(List<String> values) {
            addCriterion("xzfazd not in", values, "xzfazd");
            return (Criteria) this;
        }

        public Criteria andXzfazdBetween(String value1, String value2) {
            addCriterion("xzfazd between", value1, value2, "xzfazd");
            return (Criteria) this;
        }

        public Criteria andXzfazdNotBetween(String value1, String value2) {
            addCriterion("xzfazd not between", value1, value2, "xzfazd");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrIsNull() {
            addCriterion("xzfaqcr is null");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrIsNotNull() {
            addCriterion("xzfaqcr is not null");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrEqualTo(String value) {
            addCriterion("xzfaqcr =", value, "xzfaqcr");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrNotEqualTo(String value) {
            addCriterion("xzfaqcr <>", value, "xzfaqcr");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrGreaterThan(String value) {
            addCriterion("xzfaqcr >", value, "xzfaqcr");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrGreaterThanOrEqualTo(String value) {
            addCriterion("xzfaqcr >=", value, "xzfaqcr");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrLessThan(String value) {
            addCriterion("xzfaqcr <", value, "xzfaqcr");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrLessThanOrEqualTo(String value) {
            addCriterion("xzfaqcr <=", value, "xzfaqcr");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrLike(String value) {
            addCriterion("xzfaqcr like", value, "xzfaqcr");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrNotLike(String value) {
            addCriterion("xzfaqcr not like", value, "xzfaqcr");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrIn(List<String> values) {
            addCriterion("xzfaqcr in", values, "xzfaqcr");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrNotIn(List<String> values) {
            addCriterion("xzfaqcr not in", values, "xzfaqcr");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrBetween(String value1, String value2) {
            addCriterion("xzfaqcr between", value1, value2, "xzfaqcr");
            return (Criteria) this;
        }

        public Criteria andXzfaqcrNotBetween(String value1, String value2) {
            addCriterion("xzfaqcr not between", value1, value2, "xzfaqcr");
            return (Criteria) this;
        }

        public Criteria andXzfapzrIsNull() {
            addCriterion("xzfapzr is null");
            return (Criteria) this;
        }

        public Criteria andXzfapzrIsNotNull() {
            addCriterion("xzfapzr is not null");
            return (Criteria) this;
        }

        public Criteria andXzfapzrEqualTo(String value) {
            addCriterion("xzfapzr =", value, "xzfapzr");
            return (Criteria) this;
        }

        public Criteria andXzfapzrNotEqualTo(String value) {
            addCriterion("xzfapzr <>", value, "xzfapzr");
            return (Criteria) this;
        }

        public Criteria andXzfapzrGreaterThan(String value) {
            addCriterion("xzfapzr >", value, "xzfapzr");
            return (Criteria) this;
        }

        public Criteria andXzfapzrGreaterThanOrEqualTo(String value) {
            addCriterion("xzfapzr >=", value, "xzfapzr");
            return (Criteria) this;
        }

        public Criteria andXzfapzrLessThan(String value) {
            addCriterion("xzfapzr <", value, "xzfapzr");
            return (Criteria) this;
        }

        public Criteria andXzfapzrLessThanOrEqualTo(String value) {
            addCriterion("xzfapzr <=", value, "xzfapzr");
            return (Criteria) this;
        }

        public Criteria andXzfapzrLike(String value) {
            addCriterion("xzfapzr like", value, "xzfapzr");
            return (Criteria) this;
        }

        public Criteria andXzfapzrNotLike(String value) {
            addCriterion("xzfapzr not like", value, "xzfapzr");
            return (Criteria) this;
        }

        public Criteria andXzfapzrIn(List<String> values) {
            addCriterion("xzfapzr in", values, "xzfapzr");
            return (Criteria) this;
        }

        public Criteria andXzfapzrNotIn(List<String> values) {
            addCriterion("xzfapzr not in", values, "xzfapzr");
            return (Criteria) this;
        }

        public Criteria andXzfapzrBetween(String value1, String value2) {
            addCriterion("xzfapzr between", value1, value2, "xzfapzr");
            return (Criteria) this;
        }

        public Criteria andXzfapzrNotBetween(String value1, String value2) {
            addCriterion("xzfapzr not between", value1, value2, "xzfapzr");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkIsNull() {
            addCriterion("xzfabbqk is null");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkIsNotNull() {
            addCriterion("xzfabbqk is not null");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkEqualTo(String value) {
            addCriterion("xzfabbqk =", value, "xzfabbqk");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkNotEqualTo(String value) {
            addCriterion("xzfabbqk <>", value, "xzfabbqk");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkGreaterThan(String value) {
            addCriterion("xzfabbqk >", value, "xzfabbqk");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkGreaterThanOrEqualTo(String value) {
            addCriterion("xzfabbqk >=", value, "xzfabbqk");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkLessThan(String value) {
            addCriterion("xzfabbqk <", value, "xzfabbqk");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkLessThanOrEqualTo(String value) {
            addCriterion("xzfabbqk <=", value, "xzfabbqk");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkLike(String value) {
            addCriterion("xzfabbqk like", value, "xzfabbqk");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkNotLike(String value) {
            addCriterion("xzfabbqk not like", value, "xzfabbqk");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkIn(List<String> values) {
            addCriterion("xzfabbqk in", values, "xzfabbqk");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkNotIn(List<String> values) {
            addCriterion("xzfabbqk not in", values, "xzfabbqk");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkBetween(String value1, String value2) {
            addCriterion("xzfabbqk between", value1, value2, "xzfabbqk");
            return (Criteria) this;
        }

        public Criteria andXzfabbqkNotBetween(String value1, String value2) {
            addCriterion("xzfabbqk not between", value1, value2, "xzfabbqk");
            return (Criteria) this;
        }

        public Criteria andXzfzrIsNull() {
            addCriterion("xzfzr is null");
            return (Criteria) this;
        }

        public Criteria andXzfzrIsNotNull() {
            addCriterion("xzfzr is not null");
            return (Criteria) this;
        }

        public Criteria andXzfzrEqualTo(String value) {
            addCriterion("xzfzr =", value, "xzfzr");
            return (Criteria) this;
        }

        public Criteria andXzfzrNotEqualTo(String value) {
            addCriterion("xzfzr <>", value, "xzfzr");
            return (Criteria) this;
        }

        public Criteria andXzfzrGreaterThan(String value) {
            addCriterion("xzfzr >", value, "xzfzr");
            return (Criteria) this;
        }

        public Criteria andXzfzrGreaterThanOrEqualTo(String value) {
            addCriterion("xzfzr >=", value, "xzfzr");
            return (Criteria) this;
        }

        public Criteria andXzfzrLessThan(String value) {
            addCriterion("xzfzr <", value, "xzfzr");
            return (Criteria) this;
        }

        public Criteria andXzfzrLessThanOrEqualTo(String value) {
            addCriterion("xzfzr <=", value, "xzfzr");
            return (Criteria) this;
        }

        public Criteria andXzfzrLike(String value) {
            addCriterion("xzfzr like", value, "xzfzr");
            return (Criteria) this;
        }

        public Criteria andXzfzrNotLike(String value) {
            addCriterion("xzfzr not like", value, "xzfzr");
            return (Criteria) this;
        }

        public Criteria andXzfzrIn(List<String> values) {
            addCriterion("xzfzr in", values, "xzfzr");
            return (Criteria) this;
        }

        public Criteria andXzfzrNotIn(List<String> values) {
            addCriterion("xzfzr not in", values, "xzfzr");
            return (Criteria) this;
        }

        public Criteria andXzfzrBetween(String value1, String value2) {
            addCriterion("xzfzr between", value1, value2, "xzfzr");
            return (Criteria) this;
        }

        public Criteria andXzfzrNotBetween(String value1, String value2) {
            addCriterion("xzfzr not between", value1, value2, "xzfzr");
            return (Criteria) this;
        }

        public Criteria andHcjcdhIsNull() {
            addCriterion("hcjcdh is null");
            return (Criteria) this;
        }

        public Criteria andHcjcdhIsNotNull() {
            addCriterion("hcjcdh is not null");
            return (Criteria) this;
        }

        public Criteria andHcjcdhEqualTo(String value) {
            addCriterion("hcjcdh =", value, "hcjcdh");
            return (Criteria) this;
        }

        public Criteria andHcjcdhNotEqualTo(String value) {
            addCriterion("hcjcdh <>", value, "hcjcdh");
            return (Criteria) this;
        }

        public Criteria andHcjcdhGreaterThan(String value) {
            addCriterion("hcjcdh >", value, "hcjcdh");
            return (Criteria) this;
        }

        public Criteria andHcjcdhGreaterThanOrEqualTo(String value) {
            addCriterion("hcjcdh >=", value, "hcjcdh");
            return (Criteria) this;
        }

        public Criteria andHcjcdhLessThan(String value) {
            addCriterion("hcjcdh <", value, "hcjcdh");
            return (Criteria) this;
        }

        public Criteria andHcjcdhLessThanOrEqualTo(String value) {
            addCriterion("hcjcdh <=", value, "hcjcdh");
            return (Criteria) this;
        }

        public Criteria andHcjcdhLike(String value) {
            addCriterion("hcjcdh like", value, "hcjcdh");
            return (Criteria) this;
        }

        public Criteria andHcjcdhNotLike(String value) {
            addCriterion("hcjcdh not like", value, "hcjcdh");
            return (Criteria) this;
        }

        public Criteria andHcjcdhIn(List<String> values) {
            addCriterion("hcjcdh in", values, "hcjcdh");
            return (Criteria) this;
        }

        public Criteria andHcjcdhNotIn(List<String> values) {
            addCriterion("hcjcdh not in", values, "hcjcdh");
            return (Criteria) this;
        }

        public Criteria andHcjcdhBetween(String value1, String value2) {
            addCriterion("hcjcdh between", value1, value2, "hcjcdh");
            return (Criteria) this;
        }

        public Criteria andHcjcdhNotBetween(String value1, String value2) {
            addCriterion("hcjcdh not between", value1, value2, "hcjcdh");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIsNull() {
            addCriterion("updatetime is null");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIsNotNull() {
            addCriterion("updatetime is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeEqualTo(Date value) {
            addCriterion("updatetime =", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotEqualTo(Date value) {
            addCriterion("updatetime <>", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeGreaterThan(Date value) {
            addCriterion("updatetime >", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeGreaterThanOrEqualTo(Date value) {
            addCriterion("updatetime >=", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLessThan(Date value) {
            addCriterion("updatetime <", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLessThanOrEqualTo(Date value) {
            addCriterion("updatetime <=", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIn(List<Date> values) {
            addCriterion("updatetime in", values, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotIn(List<Date> values) {
            addCriterion("updatetime not in", values, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeBetween(Date value1, Date value2) {
            addCriterion("updatetime between", value1, value2, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotBetween(Date value1, Date value2) {
            addCriterion("updatetime not between", value1, value2, "updatetime");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}